CombatLogRemover = LibStub("AceAddon-3.0"):NewAddon("CombatLogRemover", "AceConsole-3.0" );
CombatLogRemover.db = {};

local CombatLogRemoverDefaults = {
	profile = {
		enabled = true,
	}
};

function CombatLogRemover:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("CombatLogRemoverDB", CombatLogRemoverDefaults, true);
	self.db = self.db.profile;

	self:RegisterChatCommand("combatlogremover", "SlashCommands");
	self:RegisterChatCommand("clr", "SlashCommands");
end

function CombatLogRemover:OnEnable()
	if self.db.enabled then
		self:CloseCombatChatFrame();
	end
end

function CombatLogRemover:OnDisable()
	self:OpenCombatChatFrame();
end

function CombatLogRemover:SlashCommands(msg)

	if msg == "show" then
		self.db.enabled = false;
		self:OnDisable();
	elseif msg == "hide" then
		self.db.enabled = true;
		self:OnEnable();
	elseif msg == "toggle" then
		if self.db.enabled then
			self.db.enabled = false;
			self:OnDisable();
		else
			self.db.enabled = true;
			self:OnEnable();
		end
	else
		self:Print("|cff78a3fe/clr show|r to show the Combat Log chat frame.");
		self:Print("|cff78a3fe/clr hide|r to hide the Combat Log chat frame.");
		self:Print("|cff78a3fe/clr toggle|r to show/hide the Combat Log chat frame.");
		
		if not DEFAULT_CHAT_FRAME:IsVisible() then
			FCF_SelectDockFrame(DEFAULT_CHAT_FRAME);
		end
	end
end

function CombatLogRemover:OpenCombatChatFrame()
	-- Really need to be using COMBATLOG, however it's not loaded at this point so we use ChatFrame2
	ChatFrame2.isDocked = nil;

	if (not ChatFrame2.isDocked and not ChatFrame2:IsShown()) then
		FCF_OpenNewWindow(COMBAT_LOG);
	end
end

function CombatLogRemover:CloseCombatChatFrame()
	if (ChatFrame2.isDocked or ChatFrame2:IsShown()) then
		FCF_Close(COMBATLOG);
	end

	-- This fools FCF_OpenNewWindow into thinking the chatframe exists and skips to the next open chatframe
	ChatFrame2.isDocked = 1;
end

function CombatLogRemover:Print(msg)
	msg = msg:toString();
	print("|cff66ffddCombat Log Remover: |r"..msg);
end